#include <stdio.h>
#include <stdarg.h>
#include <config/target.h>

double ca=1e1, cb=2e2, cc=3e3, cd=4e4, ce=5e5, cf=6e6, cg=7e7, ch=8e8, ci=9e9, cj=10e10, ck=11e11;

void
db (int n, ...)
{
  va_list ap;
  int i;

  va_start (ap, n);

  for (i = 0; i < n; i++)
    {
      float f = va_arg (ap, double);
      printf ("%f\n", f);
    }    

  va_end (ap);
}

void
invoke_db (void)
{
  ((void (*) (int, double, double, double, double, double, double,
	      double, double, double, double, double)) db)
    (11, ca, cb, cc, cd, ce, cf, cg, ch, ci, cj, ck);
}

void
fb (int n, ...)
{
  va_list ap;
  int i;

  va_start (ap, n);

  for (i = 0; i < n; i++)
    {
      float f = VA_ARG_FLOAT (ap);
      printf ("%f\n", f);
    }    

  va_end (ap);
}

void
invoke_fb (void)
{
  ((void (*) (int, float, float, float, float, float, float,
	      float, float, float, float, float)) fb)
    (11, ca, cb, cc, cd, ce, cf, cg, ch, ci, cj, ck);
}

int
main (int argc, char **argv)
{
  invoke_db ();
  invoke_fb ();
  return 0;
}
