<copyright> MutableDoubleArray class.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 2000 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: MutableDoubleArray.t,v 1.1 2000/04/15 09:18:27 tiggr Exp $</id>
    </copyright>

implementation class 
MutableDoubleArray : DoubleArray, MutableArray

end;

implementation instance 
MutableDoubleArray

void
  add double d
{
  [self set d at length];
}

void
  freeze
{
  //  isa = [FloatArray self];
}

extern id
  initWithCapacity int capacity;

protected id
  initWithEnumerator Enumerator e
{
  [super (DoubleArray) initWithEnumerator e];

  capacity = length;

  = self;
}

extern double
  removeAt int index;

Any
  removeAt int index
{

  double d = [self removeAt index];

  = Any ([DoubleNumber with d]);
}

extern void 
  removeElements (int, int) (start, length);

extern void
  resize (int, int) (start, num);

extern void
  set double d
   at int index;

void
  set All object
   at int index
{
  [self set [Number (object) doubleValue] at index];
}

extern void
  swap (int, int) (i, j);

end;
