/* Cygwin target OS.
   Written by Pieter J. Schoenmakers <tiggr@gerbil.org>

   Copyright (C) 1996,1999,2001 Pieter J. Schoenmakers.

   This file is part of TOM.  TOM is distributed under the terms of the
   TOM License, a copy of which can be found in the TOM distribution; see
   the file LICENSE.

   $Id: target.h,v 1.2 2001/04/27 08:16:17 bruce Exp $  */

#ifndef __ASSEMBLER__
#define HAVE_OS_OS_C 0
#define BZERO(A, N) memset((A), 0, (N))

#include <config/default.h>

// Unfortunately, cygwin's threads don't support enough stuff
//  yet for us to build correctly.  Easier to just run without.
//  - Bruce (April 21, 2001)
#define THREADS_PACKAGE THREADS_NO_THREADS
// Unfortunately, it doesn't look like cygwin's mmap is good enough.
//  So, we'll kill it for now.
//  - Bruce (April 26, 2001)
#undef HAVE_MMAP
#define SOMETHINGS_VERY_WRONG_WITH_THE_GNU_RUNTIME
#endif
