<copyright> TOM language numeric limits.
    Written by <a href="mailto:tiggr@ics.ele.tue.nl">Pieter J. Schoenmakers</a>

    Copyright &copy; 2000 Pieter J. Schoenmakers.

    This file is part of TOM.  TOM is distributed under the terms of the
    TOM License, a copy of which can be found in the TOM distribution; see
    the file LICENSE.

    <id>$Id: Limits.t,v 1.1 2000/04/16 19:06:18 tiggr Exp $</id>
    </copyright>

<doc> After discussion on the TOM mailing list in April 2000, it was
    apparent that a &lt;limits.h&gt; equivalent is useful even when the
    values are the same on every platform.  </doc>
implementation class
Limits
{
  const BYTE_MIN = 0;
  const BYTE_MAX = 255;

  const CHAR_MIN = 0;
  const CHAR_MAX = 65535;

  const INT_MIN = -2147483648;
  const INT_MAX = 2147483647;

  const LONG_MIN = -9223372036854775808L;
  const LONG_MAX = 9223372036854775807L;
}

end;

implementation instance
Limits

end;
